Declare Sub RT_Ev(TimerName as String)

Type Bullet
    X  as Double
    Y  as Double
    XL as Double
    YL as Double
    XV as Double
    YV as Double
    Active as Byte
End Type

Type BulletSystem
    Bullets as Bullet PTR
    CurrBullet as Integer
    ReloadTimer as TimerUDT
    Reload as Byte
    ReloadPic as Any PTR
    
    Declare Constructor()
    Declare Sub Control()
    Declare Sub G()
    Declare Sub GClear()
    Declare Sub NewBullet(XPos as Integer, YPos as Integer, XVector as Double, YVector as Double)
End Type

Constructor BulletSystem()
    Bullets = Allocate((MaxBullet + 1) * SizeOf(Bullet))
    ReloadPic = LoadIMGFile("imgs\reload.bmp")
    If Bullets = 0 OR ReloadPic = 0 then
        Print "[ERROR] Zero pointer in: Constructor BulletSystem()"
        Sleep
        END 0
    Endif
End Constructor


Sub BulletSystem.Control()
    Dim a as Integer
    
    For a = 0 to MaxBullet
        If Bullets[a].Active = 1 then 
            Bullets[a].XL = Bullets[a].X
            Bullets[a].YL = Bullets[a].Y
            Bullets[a].X += Bullets[a].XV
            Bullets[a].Y += Bullets[a].YV
        Endif
    Next a
    ReloadTimer.Update()
End Sub

Sub BulletSystem.G()
    Dim a as Integer
    
    For a = 0 to MaxBullet
        If Bullets[a].Active = 1 then PSET(Bullets[a].X, Bullets[a].Y), &hFFFFFF
    Next a
    If Reload = 1 then Put(1024 / 2 - 100, 768 / 2 - 50), ReloadPic, ALPHA, 200
End Sub

Sub BulletSystem.GClear()
    Dim a as Integer
    
    For a = 0 to MaxBullet
        If Bullets[a].Active = 1 then PSET(Bullets[a].XL, Bullets[a].YL), &h000000
    Next a
End Sub

Sub BulletSystem.NewBullet(XPos as Integer, YPos as Integer, XVector as Double, YVector as Double)
    If Reload = 0 then
        Bullets[CurrBullet].X = XPos
        Bullets[CurrBullet].Y = YPos
        Bullets[CurrBullet].XL = XPos
        Bullets[CurrBullet].YL = YPos
        Bullets[CurrBullet].XV = XVector
        Bullets[CurrBullet].YV = YVector
        Bullets[CurrBullet].Active = 1
        CurrBullet += 1
        If CurrBullet > MaxBullet then 
            CurrBullet = 0
            Reload = 1
            ReloadTimer.SetTimer("RT", 2, Timer_NoLoop, @RT_Ev)
        Endif
    Endif
End Sub


