Type Enemy
    X  as Double
    Y  as Double
    XL as Double
    YL as Double
    XV as Double
    YV as Double
    Life as Integer
    Active as Byte
End Type

Type EnemySystem
    Img as ANY PTR
    Ene as Enemy PTR
    CurrEne as Integer
    PS as ParticleSystem
    
    Declare Constructor()
    Declare Sub G()
    Declare Sub GClear()
    Declare Sub Control()
    Declare Sub NewEnemy()
End Type

Constructor EnemySystem()
    Img = LoadIMGFile("imgs/ene.bmp")
    If Img = 0 then
        Print "[ERROR] Could not load enemy image."
        Sleep
        END -1
    Endif
    
    Ene = Allocate((MaxEnemy + 1) * SizeOf(Enemy))
    If Ene = 0 then
        Print "[ERROR] Zero pointer in: Constructor EnemySystem()"
        Sleep 
        END -1
    Endif
End Constructor

Sub EnemySystem.G()
    Dim a as Integer
    
    For a = 0 to MaxEnemy
        If Ene[a].Active = 1 then Put(Ene[a].X, Ene[a].Y), Img, ALPHA, 255
    Next a
    PS.G()
End Sub

Sub EnemySystem.GClear()
    Dim a as Integer
    
    For a = 0 to MaxEnemy
        If Ene[a].Active = 1 then Line(Ene[a].XL, Ene[a].YL) - (Ene[a].XL + EnemySizeX, Ene[a].YL + EnemySizeY), &h000000, BF
    Next a    
    PS.GClear()
End Sub

Sub EnemySystem.Control()
    Dim a as Integer
    
    For a = 0 to MaxEnemy
        Ene[a].XL = Ene[a].X
        Ene[a].YL = Ene[a].Y
        Ene[a].X += Ene[a].XV
        Ene[a].Y += Ene[a].YV
        If Ene[a].Life <= 0 and Ene[a].Active = 1 then
            Ene[a].Active = 0
            PS.NewExplosion(Ene[a].X, Ene[a].Y)
            Score += 10
        Endif
    Next a
    PS.Control()
End Sub

Sub EnemySystem.NewEnemy()
    Ene[CurrEne].X  = RND * 1024 + 1024
    Ene[CurrEne].Y  = RND * (768 - EnemySizeY)
    Ene[CurrEne].XV = -(RND * (EnemyVXMax - 1)) - 1
    Ene[CurrEne].YV = 0
    Ene[CurrEne].Active = 1
    Ene[CurrEne].Life = LifeEnemy
    CurrEne += 1
    If CurrEne > MaxEnemy then CurrEne = 0
End Sub

