Dim Shared as Integer Score

#Include "Defines.bi"
#Include "FPSUDT.bi"
#Include "TimerUDT.bi"
#Include "LoadIMGFile.bi"
#Include "TextUDT.bi"
#Include "ParticleSystem.bi"
#Include "Intro.bi"
#Include "Bullet.bi"
#Include "Player.bi"
#Include "Enemy.bi"
#Include "Beam.bi"
#Include "Critical.bi"

Screenres 1024, 768, 32
Randomize Timer

Declare Sub IncreaseStage(Timername as String)
Declare Sub CoreReg_Ev(Timername as String)
Declare Sub CheckColl()
Declare Sub Ende()
Declare Sub TextEvEnde(TID as String)

Dim as TimeControlUDT FPS = TimeControlUDT(60)
Dim IncStage as TimerUDT = TimerUDT("IncStage", StageTimer, Timer_Loop, @IncreaseStage)

Dim Shared as Player PTR P
P = New Player(100, 100)
Dim Shared as EnemySystem PTR Ene
Ene = New EnemySystem()
Dim Shared as Beam PTR CoreDmg
CoreDmg = New Beam(200, 10, 100, 100, 4)
Dim Shared as Critical PTR CoreCrit
CoreCrit = New Critical()
Dim CoreReg as TimerUDT = TimerUDT("CoreReg", 5, Timer_Loop, @CoreReg_Ev)

Dim Shared as Integer Stage = 2
Dim as ANY PTR Background
Background = LoadIMGFile("imgs\Background.bmp")
If Background = 0 then
    Print !"[ERROR] Zero pointer in: Background = LoadIMGFile(\"imgs\\Background.bmp\")"
    Sleep
    End -1
Endif

Intro(Background)

While(NOT Multikey(&h01))
    Ene->Control
    P->Control
    CoreCrit->Control()
    IncStage.Update()
    CoreReg.Update()
    CheckColl()
    ScreenLock
        Put(0, 0), Background, ALPHA, 255
        Ene->G()
        P->G()
        Draw String(10, 10), "Score: " & Score
        Draw String(100, 10), "Core damage: "
        CoreDmg->G()
        CoreCrit->G()
    ScreenUnlock
    FPS.ControlTime()
Wend



'###############################################################################
Sub IncreaseStage(TimerName as String)
    Dim as Integer a
    
    For a = 1 to Stage
        Ene->NewEnemy()
    Next a
    If Stage < StageMax then Stage += 1
End Sub

'###############################################################################
Sub CheckColl()
    Dim as Integer a, b
    
    For a = 0 to MaxBullet
        For b = 0 to MaxEnemy
            If P->BS.Bullets[a].X >= Ene->Ene[b].X              And _
               P->BS.Bullets[a].X <= Ene->Ene[b].X + EnemySizeX And _
               P->BS.Bullets[a].Y >= Ene->Ene[b].Y              And _
               P->BS.Bullets[a].Y <= Ene->Ene[b].Y + EnemySizeY And _
               P->BS.Bullets[a].Active = 1 And Ene->Ene[b].Active = 1 then
               
               Ene->Ene[b].Life -= 1
               P->BS.Bullets[a].Active = 0
            Endif
        Next b
    Next a
    For a = 0 to MaxEnemy
        If Ene->Ene[a].X < 0 - 25 and Ene->Ene[a].Active = 1 then 
            Ene->Ene[a].Active = 0
            If CoreDmg->CurrVal > 0 then CoreDmg->CurrVal -= 5
        Endif
    Next a
    If CoreDmg->CurrVal <= 0 then Ende()
    If CoreDmg->Crit = 1 then CoreCrit->Active = 1 Else CoreCrit->Active = 0
End Sub

'###############################################################################
Sub RT_Ev(TimerName as String)
    P->BS.Reload = 0
End Sub

'###############################################################################
Sub CoreReg_Ev(TimerName as String)
    If CoreDmg->CurrVal < 100 then CoreDmg->CurrVal += 1
End Sub

'###############################################################################
Sub Ende()
    Sleep 1000
    CLS
    Dim as TextUDT I1 = TextUDT(200, 768 / 3, !"Congradulations! You got " & Score & !" Points\n\n\n" &_
                                              !"\n"                                                   &_
                                              !"Credits:\n"                                           &_
                                              !"Background: NASA/courtesy of nasaimages.org.\n"       &_
                                              !"\n"                                                   &_
                                              !"Thanks 4 playing\n"                                   &_
                                              !"Created by DonStevone\n", "I1", &h50FF00, @TextEvEnde)
    While(I1.TextEnd = 0)
        I1.Control()
        ScreenLock
            I1.GClear()
            I1.G()
        ScreenUnlock
        Sleep 10
    Wend
    Sleep 2000, 1
    END 0
End Sub
Sub TextEvEnde(TID as String)
End Sub

