Type Player
    X       as Double
    Y       as Double
    XL      as Double
    YL      as Double
    XV      as Double
    YV      as Double
    Active  as Byte
    Img     as Any PTR
    BS      as BulletSystem
    
    Declare Constructor(XPos as Integer, YPos as Integer)
    Declare Sub G()
    Declare Sub GClear()
    Declare Sub Control()
End Type

Constructor Player(XPos as Integer, YPos as Integer)
    Img = LoadIMGFile("imgs\Player.bmp")
    If Img = 0 then
        Print !"[ERROR] Can't load \"imgs\\Player.bmp\""
        Sleep
        End -1
    Endif

    X = XPos
    Y = YPos
    XL = X
    YL = Y
End Constructor

Sub Player.G()
    Put(X, Y), Img, ALPHA, 255
    BS.G()
End Sub

Sub Player.GClear()
    Line(XL - 1, YL - 1) - (XL + 51, YL + 36), &h000000, BF
    BS.GClear()
End Sub

Sub Player.Control()
    If X < 0 then X = 0
    If Y < 0 then Y = 0
    If X > 1024 - 50 then X = 1024 - 50
    If Y >  768 - 35 then Y =  768 - 35
    If Multikey(&h11) then YV -= PlayerSpeed
    If Multikey(&h1F) then YV += PlayerSpeed
    If Multikey(&h1E) then XV -= PlayerSpeed
    If Multikey(&h20) then XV += PlayerSpeed
    If XL >  PlayerSpeedMax then XL =  PlayerSpeedMax
    If XL < -PlayerSpeedMax then XL = -PlayerSpeedMax
    If YL >  PlayerSpeedMax then YL =  PlayerSpeedMax
    If YL < -PlayerSpeedMax then YL = -PlayerSpeedMax
    If Multikey(&h39) then BS.NewBullet(X + 50, Y + 17, BulletSpeed, RND * 0.5 - 0.25) : BS.NewBullet(X + 50, Y + 17, BulletSpeed, RND * 0.05 - 0.025)
    
    XV /= Reibung
    YV /= Reibung
    
    XL = X
    YL = Y
    X += XV
    Y += YV
    
    If X < 0 then XV = ABS(XV)
    If X > 1024 - 50 then XV = -ABS(XV)
    If Y < 0 then YV = ABS(YV)
    If Y > 768 - 35 then YV = -ABS(YV)
    BS.Control()
End Sub

